<?php
/**
 * This Class is for error handling and debug output
 *
 * @package Knowledgeroot
 * @author Frank Habermann
 * @version $Id: class-error.php 252 2006-11-28 21:41:01Z lordlamer $
 */
class knowledgeroot_error {
	var $CLASS = array();
	
	/**
	 * set debuglevel
	 * 0 = no debuginformations are shown
	 * 1 = debugmessages are saved to logfile
	 * 2 = debugmessages are shown to screen
	 * 3 = combine 1 and 2
	 */
	var $debuglevel = 0;
	
	/**
	 * where to save the logfile
	 */
	var $logfile = "";
	
	/**
	 * init/start class
	 */
	function start(&$CLASS) {
		$this->CLASS =& $CLASS;
	}

	/**
	* Debug_Out gibt Variableninfos aus
	*
	* Aufrufbeispiel:
	* $a = array(1, 2, array("a", "b", "c"));
	* Debug_Out($a);
	*
	* Aufruf in Knowledgeroot:
	* $this->CLASS['error']->DebugOut($foo)
	*
	* @param  mixed auszugebene Variablendaten
	* @param mixed Anweisungen fuer die switch-Abfrage
	*        'sql' - speziell formatierte Ausgabe
	* @param bool  0 (default): Ausgabe erfolgt per var_export()
	*        1: Ausgabe erfolgt per var_dump()
	*/
	function Debug_Out($input, $spezial = '', $dumpexport = 0) {
		//echo '<br />';
		$return = '';
		switch ($spezial) {
		case 'sql':
			if ($spezial == 'sql') {
				$return .= "\n".nl2br($input)."<br /><br />\n";
			}
		break;
		default:
			if (is_array($input) or is_object($input)) {
				ob_start();
				if ($dumpexport) { var_dump ($input); } else { var_export ($input); }
				$return .= "\n<pre>".ob_get_contents().'</pre><br />'."\n";
				ob_end_clean();
			}
			if (!is_array($input)) {
				$return .= $input.'<br />'."\n";
			}
			break;
		} // switch ($spezial)
		flush();

		// setze vor die Ausgabe einen deutlichen Hinweis auf die Debug-Ausgabe
		$return = '<span style="font-weight: bold;">DEBUGOUT: </span>'.
		$return."\n";
		// gib die Debuginfos aus
		echo $return;

		return true;
	}


	/**
	* DebugOut
	*
	* @see Debug_Out
	*/
	function DebugOut($input, $spezial = '', $dumpexport = 0) {
		return $this->Debug_Out($input, $spezial, $dumpexport);
	}

	/**
	 * Returns HTML-code, which is a visual representation of a multidimensional array
	 * use $this->print_array() in order to print an array
	 * Returns false if $array_in is not an array
	 * Usage:
	 * echo $this->CLASS['error']->view_array($foo)
	 *
	 * @param	array		Array to view
	 * @return	string		HTML output
	 */
	function view_array($array_in) {
		if (is_array($array_in)) {
			$result='<table border="1" cellpadding="1" cellspacing="0" bgcolor="white">';
			if (!count($array_in))	{$result.= '<tr><td><font face="Verdana,Arial" size="1"><b>'.htmlspecialchars("EMPTY!").'</b></font></td></tr>';}
			while (list($key,$val)=each($array_in))	{
				$result.= '<tr><td><font face="Verdana,Arial" size="1">'.htmlspecialchars((string)$key).'</font></td><td>';
				if (is_array($array_in[$key]))	{
					$result.=$this->view_array($array_in[$key]);
				} else
					$result.= '<font face="Verdana,Arial" size="1" color="red">'.nl2br(htmlspecialchars((string)$val)).'<br /></font>';
				$result.= '</td></tr>';
			}
			$result.= '</table>';
		} else	{
			echo "noarray";
			$result  = false;
		}
		return $result;
	}
	
	/**
	 * save message to logfile
	 * Usage: $this-CLASS['error']->log("mymessage");
	 *
	 * @param	string		string to log
	 * @param	string		sourcefile
	 */
	function log($msg,$file = "", $function = "", $row = "") {
	
	}
	
	/**
	 * show debug informations
	 */
	function debug($msg,$file = "", $function = "", $row = "") {
	
	}
}

?>